function [bb,l,h]=xyz2blh_uebung(x,y,z)
% Umwandlung: Kartesische in Ellipsoidische Koordinaten
%
% Wie:     [bb,l,h]=xyz2blh(x,y,z)
% Eingabe: X,Y,Z in Kilometer
% Ausgabe: B,L in rad, H in Kilometer
a=6378.137;
f=1/298.257223563;

b=(1-f)*a;
e1q=((a^2)-(b^2))/(a^2);  % Hilfsparameter
e2q=((a^2)-(b^2))/(b^2);  % Hilfsparameter
bb=[];l=[];h=[];  %bb...Breite, l...Lnge,h...ellipsoidische Hhe

%% erste Lsung
p=sqrt(x.^2+y.^2);
t=atan(z.*a./(p.*b));
bb=[bb;atan((z+e2q.*b.*(sin(t)).^3)./(p-e1q.*a.*(cos(t)).^3))];
l=[l;atan2(y,x)];
n=a./sqrt(1-e1q.*(sin(bb)).^2);
h = [h;p.*cos(bb) + z.*sin(bb) - a^2./n];	

end

